package com.logicbig.example;

import org.springframework.hateoas.Link;
import org.springframework.hateoas.Resource;
import org.springframework.hateoas.Resources;
import org.springframework.hateoas.mvc.ControllerLinkBuilder;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import java.util.List;

@RestController
@RequestMapping("/employees")
public class EmployeeController {

    @GetMapping(value = "/{employeeId}")
    public Resource<Employee> getEmployeeById(@PathVariable long employeeId) {
        Link selfRelLink = ControllerLinkBuilder.linkTo(
                ControllerLinkBuilder.methodOn(EmployeeController.class)
                                     .getEmployeeById(employeeId))
                                                .withSelfRel();
        Employee employee = getEmployee(employeeId);
        Resource<Employee> resource = new Resource<>(employee);
        resource.add(selfRelLink);
        return resource;
    }

    @GetMapping
    public Resources<Employee> getEmployees() {
        Link selfRelLink = ControllerLinkBuilder.linkTo(
                ControllerLinkBuilder.methodOn(EmployeeController.class)
                                     .getEmployees())
                                                .withSelfRel();
        List<Employee> employeeList = getEmployeeList();
        Resources<Employee> resources = new Resources<>(employeeList);
        resources.add(selfRelLink);
        return resources;
    }

    private List<Employee> getEmployeeList() {
        //todo: replace with employee service
        return List.of(getEmployee(1),
                Employee.create(2, "Tom", "IT", 4000));
    }

    private Employee getEmployee(long employeeId) {
        //todo: replace with employee service
        return Employee.create(employeeId, "Lara", "Admin", 3000);
    }
}